unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  LCLProc;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

  ElementD = record
    Length :Integer;
    Index  :Integer;
  end;

 TD = array of ElementD;
var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }
Function MaxLength(var AD:TD):ElementD;
var I:Integer;
begin

   Result:=AD[0];
   if High(AD) < 1 then exit;

   For I:=1 to High(AD) do
     if AD[I].Length > Result.Length then
         Result:=AD[I];
end;

Function Revers(const S:AnsiString):AnsiString;
var I,Len:Integer;
begin
   Result:=S;
   Len:=Length(S);
   For I:=1 to Len do
     Result[Len-I+1]:=S[I];
end;

procedure TForm1.Button1Click(Sender: TObject);
var A1:TD;
    StrList:TStringList;
    I:Integer;
    Maximum:ElementD;
begin
  StrList:=TStringList.Create;

  StrList.LoadFromFile('Strings.txt');

  SetLength(A1,StrList.Count);

  for I:=0 to StrList.Count-1 do
    begin
      A1[I].Index:=I;
      A1[I].Length:=UTF8Length(StrList[I]);
    end;

  Maximum:=MaxLength(A1);

  Memo1.Lines.Add('MaxLen    = '+IntToStr(Maximum.Length));
  Memo1.Lines.Add('Index     = '+IntToStr(Maximum.Index));
  Memo1.Lines.Add('MaxStr    = '+StrList[Maximum.Index]);
  Memo1.Lines.Add('ReversStr = '+AnsiToUTF8(Revers(UTF8ToAnsi(StrList[Maximum.Index]))));

  A1:=Nil;
  StrList.Free;

end;

end.

